#
#  main.rb
#  Copyright 2022 Ludovic LE ROUX <ludovic@letm-mecanique.com>
#

require 'sketchup.rb'

module LetM
  module Add_same_position
    unless file_loaded?(__FILE__)
      cmd = UI::Command.new("Add same position") {
        path = UI.openpanel("Open SKP File", "#{Dir.home}", "model.skp")
        new_definition = Sketchup.active_model.definitions.load(path)
        for e in Sketchup.active_model.selection
          if e.is_a? Sketchup::ComponentInstance
            transformation = e.transformation
            Sketchup.active_model.active_entities.add_instance(new_definition, Geom::Transformation::new(transformation))
          end
        end
      }
      cmd.menu_text = "Add same position"
      cmd.set_validation_proc {
        if Sketchup.active_model.selection.length != 0
          sortie = false
          cpt = 0
          while !sortie
            e = Sketchup.active_model.selection[cpt]
            if e.is_a? Sketchup::ComponentInstance
              MF_ENABLED
              sortie = true
            elsif cpt+1 < Sketchup.active_model.selection.length
              cpt += 1
            else
              MF_GRAYED
              sortie = true
            end
          end
        else
          MF_GRAYED
        end
      }
      UI.menu("Plugins").add_item cmd
      file_loaded(__FILE__)
    end
  end
end
